// See the file "COPYING" in the main distribution directory for copyright.
#ifndef __SPCAPNOOPWRITER__H__
#define __SPCAPNOOPWRITER__H__

#include <sys/types.h>
#include <string>
#include <cstdio>

#include "zeek/iosource/Packet.h"
#include "zeek/iosource/IOSource.h"
#include "zeek/iosource/PktDumper.h"
#include "zeek/UID.h"
#include "Writer.h"


//Writer for writing uid.pcaps

namespace SPcap {


/*Handle file pointers and invoke writes*/
//Implement writer 
class NoopWriter: public Writer<PacketBuff>  {
	public:
	NoopWriter(uint64_t bufferSize): Writer<PacketBuff> { bufferSize } {}

	ssize_t Write(std::unique_ptr<PacketBuff> pb) override
        	{
		Put(std::move(pb));
        	return 0;
        	}
};


}
#endif
