// Copyright (c) 2020-2021 by the Zeek Project. See LICENSE for details.

#pragma once

namespace spicy::zeek::configuration {

#define SPICY_HAVE_TOOLCHAIN
#define ZEEK_SPICY_PLUGIN_USE_JIT
#define ZEEK_SPICY_PLUGIN_INTERNAL_BUILD

// We make sure this is always defined, either as 0 or 1, so that we
// can catch when this header wasn't included.
#define ZEEK_DEBUG_BUILD 0

// Version of Zeek the plugin was compiled against.
#define ZEEK_SPICY_VERSION_NUMBER 40004
#define ZEEK_SPICY_BUILD_DIRECTORY "/bro/build"

inline const auto InstallLibDir = "lib";
inline const auto InstallPrefix = "/opt/corelight";

inline const auto PluginVersion = "1.2.1";
inline const int PluginVersionNumber = 10201;
inline const int PluginVersionMajor = 1;
inline const int PluginVersionMinor = 2;
inline const int PluginVersionPatch = 1;

inline const int ZeekVersionNumber = 40004;
inline const auto ZeekConfig = "/opt/corelight/bin/zeek-config";

inline const auto CxxZeekIncludeDirectories = "/opt/corelight/include";
inline const auto CxxBrokerIncludeDirectory = "/opt/internal/include";

inline const auto PluginModuleDirectory = "/opt/corelight/lib/zeek-spicy/modules";
inline const auto PluginScriptsDirectory = "";

inline const auto StaticBuildName = "spicy-plugin";

}
